diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy.h ns-3.34/src/wifi/model/wifi-phy.h
--- ns-3.33/src/wifi/model/wifi-phy.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -456,843 +292,254 @@
    * If incFlag is set, this parameter will be updated.
    * \param staId the STA-ID of the PSDU (only used for MU PPDUs)
    *
-   * \return the duration of the PSDU
-   */
-  static Time GetPayloadDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, MpduType mpdutype,
-                                  bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols,
-                                  uint16_t staId);
-  /**
-   * \param txVector the transmission parameters used for this packet
-   *
-   * \return the duration until the start of the packet
-   */
-  static Time GetStartOfPacketDuration (WifiTxVector txVector);
-
-  /**
-   * The WifiPhy::GetNModes() and WifiPhy::GetMode() methods are used
-   * (e.g., by a WifiRemoteStationManager) to determine the set of
-   * transmission/reception modes that this WifiPhy(-derived class)
-   * can support - a set of WifiMode objects which we call the
-   * DeviceRateSet, and which is stored as WifiPhy::m_deviceRateSet.
-   *
-   * It is important to note that the DeviceRateSet is a superset (not
-   * necessarily proper) of the OperationalRateSet (which is
-   * logically, if not actually, a property of the associated
-   * WifiRemoteStationManager), which itself is a superset (again, not
-   * necessarily proper) of the BSSBasicRateSet.
-   *
-   * \return the number of transmission modes supported by this PHY.
-   *
-   * \sa WifiPhy::GetMode()
-   */
-  uint8_t GetNModes (void) const;
-  /**
-   * The WifiPhy::GetNModes() and WifiPhy::GetMode() methods are used
-   * (e.g., by a WifiRemoteStationManager) to determine the set of
-   * transmission/reception modes that this WifiPhy(-derived class)
-   * can support - a set of WifiMode objects which we call the
-   * DeviceRateSet, and which is stored as WifiPhy::m_deviceRateSet.
-   *
-   * It is important to note that the DeviceRateSet is a superset (not
-   * necessarily proper) of the OperationalRateSet (which is
-   * logically, if not actually, a property of the associated
-   * WifiRemoteStationManager), which itself is a superset (again, not
-   * necessarily proper) of the BSSBasicRateSet.
-   *
-   * \param mode index in array of supported modes
-   *
-   * \return the mode whose index is specified.
-   *
-   * \sa WifiPhy::GetNModes()
-   */
-  WifiMode GetMode (uint8_t mode) const;
-  /**
-   * Check if the given WifiMode is supported by the PHY.
-   *
-   * \param mode the wifi mode to check
-   *
-   * \return true if the given mode is supported,
-   *         false otherwise
-   */
-  bool IsModeSupported (WifiMode mode) const;
-  /**
-   * Check if the given WifiMode is supported by the PHY.
-   *
-   * \param mcs the wifi mode to check
-   *
-   * \return true if the given mode is supported,
-   *         false otherwise
-   */
-  bool IsMcsSupported (WifiMode mcs) const;
-  /**
-   * Check if the given MCS of the given modulation class is supported by the PHY.
-   *
-   * \param mc the modulation class
-   * \param mcs the MCS value
-   *
-   * \return true if the given mode is supported,
-   *         false otherwise
-   */
-  bool IsMcsSupported (WifiModulationClass mc, uint8_t mcs) const;
-
-  /**
-   * \param txVector the transmission vector
-   * \param ber the probability of bit error rate
-   *
-   * \return the minimum SNR which is required to achieve
-   *          the requested BER for the specified transmission vector. (W/W)
-   */
-  double CalculateSnr (WifiTxVector txVector, double ber) const;
-
-  /**
-   * Set the Short Interframe Space (SIFS) for this PHY.
-   *
-   * \param sifs the SIFS duration
-   */
-  void SetSifs (Time sifs);
-  /**
-   * Return the Short Interframe Space (SIFS) for this PHY.
-   *
-   * \return the SIFS duration
-   */
-  Time GetSifs (void) const;
-  /**
-   * Set the slot duration for this PHY.
-   *
-   * \param slot the slot duration
-   */
-  void SetSlot (Time slot);
-  /**
-   * Return the slot duration for this PHY.
-   *
-   * \return the slot duration
-   */
-  Time GetSlot (void) const;
-  /**
-   * Set the PCF Interframe Space (PIFS) for this PHY.
-   *
-   * \param pifs the PIFS duration
-   */
-  void SetPifs (Time pifs);
-  /**
-   * Return the PCF Interframe Space (PIFS) for this PHY.
-   *
-   * \return the PIFS duration
-   */
-  Time GetPifs (void) const;
-  /**
-   * Return the estimated Ack TX time for this PHY.
-   *
-   * \return the estimated Ack TX time
-   */
-  Time GetAckTxTime (void) const;
-  /**
-   * Return the estimated BlockAck TX time for this PHY.
-   *
-   * \return the estimated BlockAck TX time
-   */
-  Time GetBlockAckTxTime (void) const;
-
-  /**
-  * The WifiPhy::NBssMembershipSelectors() method is used
-  * (e.g., by a WifiRemoteStationManager) to determine the set of
-  * transmission/reception modes that this WifiPhy(-derived class)
-  * can support - a set of WifiMode objects which we call the
-  * BssMembershipSelectorSet, and which is stored as WifiPhy::m_bssMembershipSelectorSet.
-  *
-  * \return the membership selector whose index is specified.
-  */
-  uint8_t GetNBssMembershipSelectors (void) const;
-  /**
-  * The WifiPhy::BssMembershipSelector() method is used
-  * (e.g., by a WifiRemoteStationManager) to determine the set of
-  * transmission/reception modes that this WifiPhy(-derived class)
-  * can support - a set of WifiMode objects which we call the
-  * BssMembershipSelectorSet, and which is stored as WifiPhy::m_bssMembershipSelectorSet.
-  *
-  * \param selector index in array of supported memberships
-  *
-  * \return the membership selector whose index is specified.
-  */
-  uint8_t GetBssMembershipSelector (uint8_t selector) const;
-  /**
-   * The WifiPhy::GetNMcs() method is used
-   * (e.g., by a WifiRemoteStationManager) to determine the set of
-   * transmission/reception MCS indexes that this WifiPhy(-derived class)
-   * can support - a set of MCS indexes which we call the
-   * DeviceMcsSet, and which is stored as WifiPhy::m_deviceMcsSet.
-   *
-   * \return the MCS index whose index is specified.
-   */
-  uint8_t GetNMcs (void) const;
-  /**
-   * The WifiPhy::GetMcs() method is used
-   * (e.g., by a WifiRemoteStationManager) to determine the set of
-   * transmission/reception MCS indexes that this WifiPhy(-derived class)
-   * can support - a set of MCS indexes which we call the
-   * DeviceMcsSet, and which is stored as WifiPhy::m_deviceMcsSet.
-   *
-   * \param mcs index in array of supported MCS
-   *
-   * \return the MCS index whose index is specified.
-   */
-  WifiMode GetMcs (uint8_t mcs) const;
-  /**
-   * Get the WifiMode object corresponding to the given MCS of the given
-   * modulation class.
-   *
-   * \param modulation the modulation class
-   * \param mcs the MCS value
-   *
-   * \return the WifiMode object corresponding to the given MCS of the given
-   *         modulation class
-   */
-  WifiMode GetMcs (WifiModulationClass modulation, uint8_t mcs) const;
-  /**
-   * Get the WifiMode object corresponding to the given MCS of the
-   * HT modulation class.
-   *
-   * \param mcs the MCS value
-   *
-   * \return the WifiMode object corresponding to the given MCS of the
-   *         HT modulation class
-   */
-  static WifiMode GetHtMcs (uint8_t mcs);
-  /**
-   * Get the WifiMode object corresponding to the given MCS of the
-   * VHT modulation class.
-   *
-   * \param mcs the MCS value
-   *
-   * \return the WifiMode object corresponding to the given MCS of the
-   *         VHT modulation class
-   */
-  static WifiMode GetVhtMcs (uint8_t mcs);
-  /**
-   * Get the WifiMode object corresponding to the given MCS of the
-   * HE modulation class.
-   *
-   * \param mcs the MCS value
-   *
-   * \return the WifiMode object corresponding to the given MCS of the
-   *         HE modulation class
-   */
-  static WifiMode GetHeMcs (uint8_t mcs);
-
-  /**
-   * \brief Set channel number.
-   *
-   * Channel center frequency = Channel starting frequency + 5 MHz * (nch - 1)
-   *
-   * where Starting channel frequency is standard-dependent,
-   * as defined in (Section 18.3.8.4.2 "Channel numbering"; IEEE Std 802.11-2012).
-   * This method may fail to take action if the PHY model determines that
-   * the channel number cannot be switched for some reason (e.g. sleep state)
-   *
-   * \param id the channel number
-   */
-  virtual void SetChannelNumber (uint8_t id);
-  /**
-   * Return current channel number.
-   *
-   * \return the current channel number
-   */
-  uint8_t GetChannelNumber (void) const;
-  /**
-   * \return the required time for channel switch operation of this WifiPhy
-   */
-  Time GetChannelSwitchDelay (void) const;
-
-  /**
-   * Configure the PHY-level parameters for different Wi-Fi standard.
-   *
-   * \param standard the Wi-Fi standard
-   * \param band the Wi-Fi band
-   */
-  virtual void ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band);
-
-  /**
-   * Get the configured Wi-Fi standard
-   *
-   * \return the Wi-Fi standard that has been configured
-   */
-  WifiPhyStandard GetPhyStandard (void) const;
-
-  /**
-   * Get the configured Wi-Fi band
-   *
-   * \return the Wi-Fi band that has been configured
-   */
-  WifiPhyBand GetPhyBand (void) const;
-
-  /**
-   * Add a channel definition to the WifiPhy. The channelNumber, PHY
-   * band and PHY standard informations may then be used to lookup a
-   * pair (frequency, channelWidth).
-   *
-   * If the channel is not already defined for the standard, the method
-   * should return true; otherwise false.
-   *
-   * \param channelNumber the channel number to define
-   * \param band the PHY band which the channel belongs to
-   * \param standard the applicable WifiPhyStandard
-   * \param frequency the frequency (MHz)
-   * \param channelWidth the channel width (MHz)
-   *
-   * \return true if the channel definition succeeded
-   */
-  bool DefineChannelNumber (uint8_t channelNumber, WifiPhyBand band, WifiPhyStandard standard, uint16_t frequency, uint16_t channelWidth);
-
-  /**
-   * Return the Channel this WifiPhy is connected to.
-   *
-   * \return the Channel this WifiPhy is connected to
-   */
-  virtual Ptr<Channel> GetChannel (void) const = 0;
-
-  /**
-   * Return a WifiMode for DSSS at 1Mbps.
-   *
-   * \return a WifiMode for DSSS at 1Mbps
-   */
-  static WifiMode GetDsssRate1Mbps ();
-  /**
-   * Return a WifiMode for DSSS at 2Mbps.
-   *
-   * \return a WifiMode for DSSS at 2Mbps
-   */
-  static WifiMode GetDsssRate2Mbps ();
-  /**
-   * Return a WifiMode for DSSS at 5.5Mbps.
-   *
-   * \return a WifiMode for DSSS at 5.5Mbps
-   */
-  static WifiMode GetDsssRate5_5Mbps ();
-  /**
-   * Return a WifiMode for DSSS at 11Mbps.
-   *
-   * \return a WifiMode for DSSS at 11Mbps
-   */
-  static WifiMode GetDsssRate11Mbps ();
-  /**
-   * Return a WifiMode for ERP-OFDM at 6Mbps.
-   *
-   * \return a WifiMode for ERP-OFDM at 6Mbps
-   */
-  static WifiMode GetErpOfdmRate6Mbps ();
-  /**
-   * Return a WifiMode for ERP-OFDM at 9Mbps.
-   *
-   * \return a WifiMode for ERP-OFDM at 9Mbps
-   */
-  static WifiMode GetErpOfdmRate9Mbps ();
-  /**
-   * Return a WifiMode for ERP-OFDM at 12Mbps.
-   *
-   * \return a WifiMode for ERP-OFDM at 12Mbps
-   */
-  static WifiMode GetErpOfdmRate12Mbps ();
-  /**
-   * Return a WifiMode for ERP-OFDM at 18Mbps.
-   *
-   * \return a WifiMode for ERP-OFDM at 18Mbps
-   */
-  static WifiMode GetErpOfdmRate18Mbps ();
-  /**
-   * Return a WifiMode for ERP-OFDM at 24Mbps.
-   *
-   * \return a WifiMode for ERP-OFDM at 24Mbps
-   */
-  static WifiMode GetErpOfdmRate24Mbps ();
-  /**
-   * Return a WifiMode for ERP-OFDM at 36Mbps.
-   *
-   * \return a WifiMode for ERP-OFDM at 36Mbps
-   */
-  static WifiMode GetErpOfdmRate36Mbps ();
-  /**
-   * Return a WifiMode for ERP-OFDM at 48Mbps.
-   *
-   * \return a WifiMode for ERP-OFDM at 48Mbps
-   */
-  static WifiMode GetErpOfdmRate48Mbps ();
-  /**
-   * Return a WifiMode for ERP-OFDM at 54Mbps.
-   *
-   * \return a WifiMode for ERP-OFDM at 54Mbps
-   */
-  static WifiMode GetErpOfdmRate54Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 6Mbps.
-   *
-   * \return a WifiMode for OFDM at 6Mbps
-   */
-  static WifiMode GetOfdmRate6Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 9Mbps.
-   *
-   * \return a WifiMode for OFDM at 9Mbps
-   */
-  static WifiMode GetOfdmRate9Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 12Mbps.
-   *
-   * \return a WifiMode for OFDM at 12Mbps
-   */
-  static WifiMode GetOfdmRate12Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 18Mbps.
-   *
-   * \return a WifiMode for OFDM at 18Mbps
-   */
-  static WifiMode GetOfdmRate18Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 24Mbps.
-   *
-   * \return a WifiMode for OFDM at 24Mbps
-   */
-  static WifiMode GetOfdmRate24Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 36Mbps.
-   *
-   * \return a WifiMode for OFDM at 36Mbps
-   */
-  static WifiMode GetOfdmRate36Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 48Mbps.
-   *
-   * \return a WifiMode for OFDM at 48Mbps
-   */
-  static WifiMode GetOfdmRate48Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 54Mbps.
-   *
-   * \return a WifiMode for OFDM at 54Mbps
-   */
-  static WifiMode GetOfdmRate54Mbps ();
-  /**
-   * Return a WifiMode for OFDM at 3Mbps with 10MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 3Mbps with 10MHz channel spacing
-   */
-  static WifiMode GetOfdmRate3MbpsBW10MHz ();
-  /**
-   * Return a WifiMode for OFDM at 4.5Mbps with 10MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 4.5Mbps with 10MHz channel spacing
-   */
-  static WifiMode GetOfdmRate4_5MbpsBW10MHz ();
-  /**
-   * Return a WifiMode for OFDM at 6Mbps with 10MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 6Mbps with 10MHz channel spacing
-   */
-  static WifiMode GetOfdmRate6MbpsBW10MHz ();
-  /**
-   * Return a WifiMode for OFDM at 9Mbps with 10MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 9Mbps with 10MHz channel spacing
-   */
-  static WifiMode GetOfdmRate9MbpsBW10MHz ();
-  /**
-   * Return a WifiMode for OFDM at 12Mbps with 10MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 12Mbps with 10MHz channel spacing
-   */
-  static WifiMode GetOfdmRate12MbpsBW10MHz ();
-  /**
-   * Return a WifiMode for OFDM at 18Mbps with 10MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 18Mbps with 10MHz channel spacing
-   */
-  static WifiMode GetOfdmRate18MbpsBW10MHz ();
-  /**
-   * Return a WifiMode for OFDM at 24Mbps with 10MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 24Mbps with 10MHz channel spacing
-   */
-  static WifiMode GetOfdmRate24MbpsBW10MHz ();
-  /**
-   * Return a WifiMode for OFDM at 27Mbps with 10MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 27Mbps with 10MHz channel spacing
-   */
-  static WifiMode GetOfdmRate27MbpsBW10MHz ();
-  /**
-   * Return a WifiMode for OFDM at 1.5Mbps with 5MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 1.5Mbps with 5MHz channel spacing
-   */
-  static WifiMode GetOfdmRate1_5MbpsBW5MHz ();
-  /**
-   * Return a WifiMode for OFDM at 2.25Mbps with 5MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 2.25Mbps with 5MHz channel spacing
-   */
-  static WifiMode GetOfdmRate2_25MbpsBW5MHz ();
-  /**
-   * Return a WifiMode for OFDM at 3Mbps with 5MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 3Mbps with 5MHz channel spacing
-   */
-  static WifiMode GetOfdmRate3MbpsBW5MHz ();
-  /**
-   * Return a WifiMode for OFDM at 4.5Mbps with 5MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 4.5Mbps with 5MHz channel spacing
-   */
-  static WifiMode GetOfdmRate4_5MbpsBW5MHz ();
-  /**
-   * Return a WifiMode for OFDM at 6Mbps with 5MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 6Mbps with 5MHz channel spacing
-   */
-  static WifiMode GetOfdmRate6MbpsBW5MHz ();
-  /**
-   * Return a WifiMode for OFDM at 9Mbps with 5MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 9Mbps with 5MHz channel spacing
-   */
-  static WifiMode GetOfdmRate9MbpsBW5MHz ();
-  /**
-   * Return a WifiMode for OFDM at 12Mbps with 5MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 12Mbps with 5MHz channel spacing
-   */
-  static WifiMode GetOfdmRate12MbpsBW5MHz ();
-  /**
-   * Return a WifiMode for OFDM at 13.5Mbps with 5MHz channel spacing.
-   *
-   * \return a WifiMode for OFDM at 13.5Mbps with 5MHz channel spacing
-   */
-  static WifiMode GetOfdmRate13_5MbpsBW5MHz ();
-
-  /**
-   * Return MCS 0 from HT MCS values.
-   *
-   * \return MCS 0 from HT MCS values
-   */
-  static WifiMode GetHtMcs0 ();
-  /**
-   * Return MCS 1 from HT MCS values.
-   *
-   * \return MCS 1 from HT MCS values
-   */
-  static WifiMode GetHtMcs1 ();
-  /**
-   * Return MCS 2 from HT MCS values.
-   *
-   * \return MCS 2 from HT MCS values
-   */
-  static WifiMode GetHtMcs2 ();
-  /**
-   * Return MCS 3 from HT MCS values.
-   *
-   * \return MCS 3 from HT MCS values
-   */
-  static WifiMode GetHtMcs3 ();
-  /**
-   * Return MCS 4 from HT MCS values.
-   *
-   * \return MCS 4 from HT MCS values
-   */
-  static WifiMode GetHtMcs4 ();
-  /**
-   * Return MCS 5 from HT MCS values.
-   *
-   * \return MCS 5 from HT MCS values
-   */
-  static WifiMode GetHtMcs5 ();
-  /**
-   * Return MCS 6 from HT MCS values.
-   *
-   * \return MCS 6 from HT MCS values
-   */
-  static WifiMode GetHtMcs6 ();
-  /**
-   * Return MCS 7 from HT MCS values.
-   *
-   * \return MCS 7 from HT MCS values
-   */
-  static WifiMode GetHtMcs7 ();
-  /**
-   * Return MCS 8 from HT MCS values.
-   *
-   * \return MCS 8 from HT MCS values
-   */
-  static WifiMode GetHtMcs8 ();
-  /**
-   * Return MCS 9 from HT MCS values.
-   *
-   * \return MCS 9 from HT MCS values
-   */
-  static WifiMode GetHtMcs9 ();
-  /**
-   * Return MCS 10 from HT MCS values.
-   *
-   * \return MCS 10 from HT MCS values
-   */
-  static WifiMode GetHtMcs10 ();
-  /**
-   * Return MCS 11 from HT MCS values.
-   *
-   * \return MCS 11 from HT MCS values
-   */
-  static WifiMode GetHtMcs11 ();
-  /**
-   * Return MCS 12 from HT MCS values.
-   *
-   * \return MCS 12 from HT MCS values
-   */
-  static WifiMode GetHtMcs12 ();
-  /**
-   * Return MCS 13 from HT MCS values.
-   *
-   * \return MCS 13 from HT MCS values
-   */
-  static WifiMode GetHtMcs13 ();
-  /**
-   * Return MCS 14 from HT MCS values.
-   *
-   * \return MCS 14 from HT MCS values
-   */
-  static WifiMode GetHtMcs14 ();
-  /**
-   * Return MCS 15 from HT MCS values.
-   *
-   * \return MCS 15 from HT MCS values
+   * \return the duration of the PSDU
    */
-  static WifiMode GetHtMcs15 ();
+  static Time GetPayloadDuration (uint32_t size, const WifiTxVector& txVector, WifiPhyBand band, MpduType mpdutype,
+                                  bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols,
+                                  uint16_t staId);
   /**
-   * Return MCS 16 from HT MCS values.
+   * \param txVector the transmission parameters used for this packet
    *
-   * \return MCS 16 from HT MCS values
+   * \return the duration until the start of the packet
    */
-  static WifiMode GetHtMcs16 ();
+  static Time GetStartOfPacketDuration (const WifiTxVector& txVector);
+
   /**
-   * Return MCS 17 from HT MCS values.
+   * The WifiPhy::GetModeList() method is used
+   * (e.g., by a WifiRemoteStationManager) to determine the set of
+   * transmission/reception (non-MCS) modes that this WifiPhy(-derived class)
+   * can support - a set of modes which is stored by each non-HT PHY.
    *
-   * \return MCS 17 from HT MCS values
-   */
-  static WifiMode GetHtMcs17 ();
-  /**
-   * Return MCS 18 from HT MCS values.
+   * It is important to note that this list is a superset (not
+   * necessarily proper) of the OperationalRateSet (which is
+   * logically, if not actually, a property of the associated
+   * WifiRemoteStationManager), which itself is a superset (again, not
+   * necessarily proper) of the BSSBasicRateSet.
    *
-   * \return MCS 18 from HT MCS values
+   * \return the list of supported (non-MCS) modes.
    */
-  static WifiMode GetHtMcs18 ();
+  std::list<WifiMode> GetModeList (void) const;
   /**
-   * Return MCS 19 from HT MCS values.
+   * Get the list of supported (non-MCS) modes for the given modulation class (i.e.
+   * corresponding to a given PHY entity).
    *
-   * \return MCS 19 from HT MCS values
-   */
-  static WifiMode GetHtMcs19 ();
-  /**
-   * Return MCS 20 from HT MCS values.
+   * \param modulation the modulation class
+   * \return the list of supported (non-MCS) modes for the given modulation class.
    *
-   * \return MCS 20 from HT MCS values
+   * \see GetModeList (void)
    */
-  static WifiMode GetHtMcs20 ();
+  std::list<WifiMode> GetModeList (WifiModulationClass modulation) const;
   /**
-   * Return MCS 21 from HT MCS values.
+   * Check if the given WifiMode is supported by the PHY.
    *
-   * \return MCS 21 from HT MCS values
-   */
-  static WifiMode GetHtMcs21 ();
-  /**
-   * Return MCS 22 from HT MCS values.
+   * \param mode the wifi mode to check
    *
-   * \return MCS 22 from HT MCS values
+   * \return true if the given mode is supported,
+   *         false otherwise
    */
-  static WifiMode GetHtMcs22 ();
+  bool IsModeSupported (WifiMode mode) const;
   /**
-   * Return MCS 23 from HT MCS values.
+   * Get the default WifiMode supported by the PHY.
+   * This is the first mode to be added (i.e. the lowest one
+   * over all supported PHY entities).
    *
-   * \return MCS 23 from HT MCS values
+   * \return the default WifiMode
    */
-  static WifiMode GetHtMcs23 ();
+  WifiMode GetDefaultMode (void) const;
   /**
-   * Return MCS 24 from HT MCS values.
+   * Check if the given MCS of the given modulation class is supported by the PHY.
    *
-   * \return MCS 24 from HT MCS values
-   */
-  static WifiMode GetHtMcs24 ();
-  /**
-   * Return MCS 25 from HT MCS values.
+   * \param modulation the modulation class
+   * \param mcs the MCS value
    *
-   * \return MCS 25 from HT MCS values
+   * \return true if the given mode is supported,
+   *         false otherwise
    */
-  static WifiMode GetHtMcs25 ();
+  bool IsMcsSupported (WifiModulationClass modulation, uint8_t mcs) const;
+
   /**
-   * Return MCS 26 from HT MCS values.
+   * \param txVector the transmission vector
+   * \param ber the probability of bit error rate
    *
-   * \return MCS 26 from HT MCS values
+   * \return the minimum SNR which is required to achieve
+   *          the requested BER for the specified transmission vector. (W/W)
    */
-  static WifiMode GetHtMcs26 ();
+  double CalculateSnr (const WifiTxVector& txVector, double ber) const;
+
   /**
-   * Return MCS 27 from HT MCS values.
+   * Set the Short Interframe Space (SIFS) for this PHY.
    *
-   * \return MCS 27 from HT MCS values
+   * \param sifs the SIFS duration
    */
-  static WifiMode GetHtMcs27 ();
+  void SetSifs (Time sifs);
   /**
-   * Return MCS 28 from HT MCS values.
+   * Return the Short Interframe Space (SIFS) for this PHY.
    *
-   * \return MCS 28 from HT MCS values
+   * \return the SIFS duration
    */
-  static WifiMode GetHtMcs28 ();
+  Time GetSifs (void) const;
   /**
-   * Return MCS 29 from HT MCS values.
+   * Set the slot duration for this PHY.
    *
-   * \return MCS 29 from HT MCS values
+   * \param slot the slot duration
    */
-  static WifiMode GetHtMcs29 ();
+  void SetSlot (Time slot);
   /**
-   * Return MCS 30 from HT MCS values.
+   * Return the slot duration for this PHY.
    *
-   * \return MCS 30 from HT MCS values
+   * \return the slot duration
    */
-  static WifiMode GetHtMcs30 ();
+  Time GetSlot (void) const;
   /**
-   * Return MCS 31 from HT MCS values.
+   * Set the PCF Interframe Space (PIFS) for this PHY.
    *
-   * \return MCS 31 from HT MCS values
+   * \param pifs the PIFS duration
    */
-  static WifiMode GetHtMcs31 ();
-
+  void SetPifs (Time pifs);
   /**
-   * Return MCS 0 from VHT MCS values.
+   * Return the PCF Interframe Space (PIFS) for this PHY.
    *
-   * \return MCS 0 from VHT MCS values
+   * \return the PIFS duration
    */
-  static WifiMode GetVhtMcs0 ();
+  Time GetPifs (void) const;
   /**
-   * Return MCS 1 from VHT MCS values.
+   * Return the estimated Ack TX time for this PHY.
    *
-   * \return MCS 1 from VHT MCS values
+   * \return the estimated Ack TX time
    */
-  static WifiMode GetVhtMcs1 ();
+  Time GetAckTxTime (void) const;
   /**
-   * Return MCS 2 from VHT MCS values.
+   * Return the estimated BlockAck TX time for this PHY.
    *
-   * \return MCS 2 from VHT MCS values
+   * \return the estimated BlockAck TX time
    */
-  static WifiMode GetVhtMcs2 ();
+  Time GetBlockAckTxTime (void) const;
+
   /**
-   * Return MCS 3 from VHT MCS values.
+   * Get the maximum PSDU size in bytes for the given modulation class.
    *
-   * \return MCS 3 from VHT MCS values
+   * \param modulation the modulation class
+   * \return the maximum PSDU size in bytes for the given modulation class
    */
-  static WifiMode GetVhtMcs3 ();
+  static uint32_t GetMaxPsduSize (WifiModulationClass modulation);
+
   /**
-   * Return MCS 4 from VHT MCS values.
-   *
-   * \return MCS 4 from VHT MCS values
-   */
-  static WifiMode GetVhtMcs4 ();
+  * The WifiPhy::BssMembershipSelector() method is used
+  * (e.g., by a WifiRemoteStationManager) to determine the set of
+  * transmission/reception modes that this WifiPhy(-derived class)
+  * can support - a set of WifiMode objects which we call the
+  * BssMembershipSelectorSet, and which is stored inside HT PHY (and above)
+  * instances.
+  *
+  * \return the list of BSS membership selectors.
+  */
+  std::list<uint8_t> GetBssMembershipSelectorList (void) const;
   /**
-   * Return MCS 5 from VHT MCS values.
+   * \return the number of supported MCSs.
    *
-   * \return MCS 5 from VHT MCS values
+   * \see GetMcsList (void)
    */
-  static WifiMode GetVhtMcs5 ();
+  uint16_t GetNMcs (void) const;
   /**
-   * Return MCS 6 from VHT MCS values.
+   * The WifiPhy::GetMcsList() method is used
+   * (e.g., by a WifiRemoteStationManager) to determine the set of
+   * transmission/reception MCS indices that this WifiPhy(-derived class)
+   * can support - a set of MCS indices which is stored by each HT PHY (and above).
    *
-   * \return MCS 6 from VHT MCS values
+   * \return the list of supported MCSs.
    */
-  static WifiMode GetVhtMcs6 ();
+  std::list<WifiMode> GetMcsList (void) const;
   /**
-   * Return MCS 7 from VHT MCS values.
+   * Get the list of supported MCSs for the given modulation class (i.e.
+   * corresponding to a given PHY entity).
    *
-   * \return MCS 7 from VHT MCS values
-   */
-  static WifiMode GetVhtMcs7 ();
-  /**
-   * Return MCS 8 from VHT MCS values.
+   * \param modulation the modulation class
+   * \return the list of supported MCSs for the given modulation class.
    *
-   * \return MCS 8 from VHT MCS values
+   * \see GetMcsList (void)
    */
-  static WifiMode GetVhtMcs8 ();
+  std::list<WifiMode> GetMcsList (WifiModulationClass modulation) const;
   /**
-   * Return MCS 9 from VHT MCS values.
+   * Get the WifiMode object corresponding to the given MCS of the given
+   * modulation class.
    *
-   * \return MCS 9 from VHT MCS values
-   */
-  static WifiMode GetVhtMcs9 ();
-
-  /**
-   * Return MCS 0 from HE MCS values.
+   * \param modulation the modulation class
+   * \param mcs the MCS value
    *
-   * \return MCS 0 from HE MCS values
+   * \return the WifiMode object corresponding to the given MCS of the given
+   *         modulation class
    */
-  static WifiMode GetHeMcs0 ();
+  WifiMode GetMcs (WifiModulationClass modulation, uint8_t mcs) const;
+
   /**
-   * Return MCS 1 from HE MCS values.
+   * \brief Set channel number.
    *
-   * \return MCS 1 from HE MCS values
-   */
-  static WifiMode GetHeMcs1 ();
-  /**
-   * Return MCS 2 from HE MCS values.
+   * Channel center frequency = Channel starting frequency + 5 MHz * (nch - 1)
    *
-   * \return MCS 2 from HE MCS values
-   */
-  static WifiMode GetHeMcs2 ();
-  /**
-   * Return MCS 3 from HE MCS values.
+   * where Starting channel frequency is standard-dependent,
+   * as defined in (Section 18.3.8.4.2 "Channel numbering"; IEEE Std 802.11-2012).
    *
-   * \return MCS 3 from HE MCS values
-   */
-  static WifiMode GetHeMcs3 ();
-  /**
-   * Return MCS 4 from HE MCS values.
+   * If the operating channel for this object has not been set yet, the given
+   * channel number is saved and will be used, along with the center frequency and
+   * width that have been saved similarly, to set the operating channel when the
+   * standard and band are configured. Note that if center frequency and channel
+   * number are both 0 when the standard and band are configured, a default channel
+   * (of the configured width, if any, or the default width for the current standard
+   * and band, otherwise) is set.
+   * If the operating channel for this object has been already set, the specified
+   * channel number must uniquely identify a channel in the band being used. If so,
+   * this method may still fail to take action if the PHY model determines that
+   * the channel number cannot be switched for some reason (e.g. sleep state)
    *
-   * \return MCS 4 from HE MCS values
+   * \param id the channel number
    */
-  static WifiMode GetHeMcs4 ();
+  virtual void SetChannelNumber (uint8_t id);
   /**
-   * Return MCS 5 from HE MCS values.
+   * Return current channel number.
    *
-   * \return MCS 5 from HE MCS values
+   * \return the current channel number
    */
-  static WifiMode GetHeMcs5 ();
+  uint8_t GetChannelNumber (void) const;
   /**
-   * Return MCS 6 from HE MCS values.
-   *
-   * \return MCS 6 from HE MCS values
+   * \return the required time for channel switch operation of this WifiPhy
    */
-  static WifiMode GetHeMcs6 ();
+  Time GetChannelSwitchDelay (void) const;
+
   /**
-   * Return MCS 7 from HE MCS values.
+   * Configure the PHY-level parameters for different Wi-Fi standard.
    *
-   * \return MCS 7 from HE MCS values
+   * \param standard the Wi-Fi standard
+   * \param band the Wi-Fi band
    */
-  static WifiMode GetHeMcs7 ();
+  virtual void ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band);
+
   /**
-   * Return MCS 8 from HE MCS values.
+   * Get the configured Wi-Fi standard
    *
-   * \return MCS 8 from HE MCS values
+   * \return the Wi-Fi standard that has been configured
    */
-  static WifiMode GetHeMcs8 ();
+  WifiPhyStandard GetPhyStandard (void) const;
+
   /**
-   * Return MCS 9 from HE MCS values.
+   * Get the configured Wi-Fi band
    *
-   * \return MCS 9 from HE MCS values
+   * \return the Wi-Fi band that has been configured
    */
-  static WifiMode GetHeMcs9 ();
+  WifiPhyBand GetPhyBand (void) const;
+
   /**
-   * Return MCS 10 from HE MCS values.
+   * Get a const reference to the operating channel
    *
-   * \return MCS 10 from HE MCS values
+   * \return a const reference to the operating channel
    */
-  static WifiMode GetHeMcs10 ();
+  const WifiPhyOperatingChannel& GetOperatingChannel (void) const;
+
   /**
-   * Return MCS 11 from HE MCS values.
+   * Return the Channel this WifiPhy is connected to.
    *
-   * \return MCS 11 from HE MCS values
+   * \return the Channel this WifiPhy is connected to
    */
-  static WifiMode GetHeMcs11 ();
+  virtual Ptr<Channel> GetChannel (void) const = 0;
 
   /**
    * Public method used to fire a PhyTxBegin trace.
